//   -  MT10S1, MT16S2, MT20S2, MT24S2, MT20S4    8-  .

#define	MT10S1		//     : MT10S1, MT16S2, MT20S2, MT24S2, MT20S4.

#ifdef	MT10S1		//    MT10S1
#define	Len1	8	//      (10       !)
#define	Len2	2	//     
#define	Len3	0	//     
#define	Len4	0	//     
const char Text1[Len1]={	'','','','',' ','1','0','S'		};
const char Text2[Len2]={	'1',24					};
#endif

#ifdef	MT16S2		//    MT16S2
#define	Len1	16	//     
#define	Len2	16	//     
#define	Len3	0	//     
#define	Len4	0	//     
const char Text1[Len1]={	'','','','',' ','1','6','S','2',' ',24,25,136,15,10,9	};
const char Text2[Len2]={	20,37,42,134,135,250,251,252,253,254,255,30,241,242,240,50	};
#endif

#ifdef	MT20S2		//    MT20S2
#define	Len1	20	//     
#define	Len2	20	//     
#define	Len3	0	//     
#define	Len4	0	//     
const char Text1[Len1]={	'','','',' ','','','','',' ','2','0','S','2',' ',24,25,136,15,10,9	};
const char Text2[Len2]={	43,45,177,20,37,42,134,135,23,250,251,252,253,254,255,30,241,242,240,50		};
#endif

#ifdef	MT24S2		//    MT24S2
#define	Len1	24	//     
#define	Len2	24	//     
#define	Len3	0	//     
#define	Len4	0	//     
const char Text1[Len1]={	'','','',' ','','','','',' ','2','4','S','2',' ',24,25,136,15,10,9,22,132,133,21	};
const char Text2[Len2]={	43,45,177,20,37,42,134,135,23,40,41,27,26,250,251,252,253,254,255,30,241,242,240,50	};
#endif

#ifdef	MT20S4		//    MT20S4
#define	Len1	20	//     
#define	Len2	20	//     
#define	Len3	20	//     
#define	Len4	20	//     
const char Text1[Len1]={	'','','',' ','','','','',' ','2','0','S','4',' ',24,25,136,10,9,133	};
const char Text2[Len2]={	'@','A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S'	};
const char Text3[Len3]={	'T','U','V','W','X','Y','Z','[',']',94,95,35,33,47,38,11,12,13,14,15		};
const char Text4[Len4]={	43,45,177,20,37,42,134,135,23,250,251,252,253,254,255,30,241,242,240,50		};
#endif


void main(void) {
int i;

	LCDinit();
	WriteCmd(0x80);		//      
#if Len1>0
	for(i=0;i<Len1;i++) { WriteData(Text1[i]); }
#endif
#if Len3>0
	for(i=0;i<Len3;i++) { WriteData(Text3[i]); }	//          
#endif
	WriteCmd(0x80+0x40);	//      
#if Len2>0
	for(i=0;i<Len2;i++) { WriteData(Text2[i]); }
#endif
#if Len4>0
	for(i=0;i<Len4;i++) { WriteData(Text4[i]); }	//          
#endif
}

void LCDinit(void) {
	LCD.E=0; Delay(>20ms);
//       
	LCD.RW=0; LCD.A0=0; LCD.D=0x30;	//   (8 )
	Delay(>40ns);		//    (tAS)
	LCD.E=1; Delay(>230ns);	//     (tDSW)
	LCD.E=0; Delay(>40us);	//  
	LCD.E=1; Delay(>230ns);	//    E=1
	LCD.E=0; Delay(>40us);	//  
	LCD.E=1; Delay(>230ns);
	LCD.E=0; Delay(>270ns);	//     E=1
//               
	WriteCmd(0x3A);		//   
	WriteCmd(0x0C);		// ,  
	WriteCmd(0x01);		// 
	WriteCmd(0x06);		//   :   
}

void WriteCmd(byte b) { WriteByte(b,0); }

void WriteData(byte b) { WriteByte(b,1); }

void WriteByte(byte b, bit cd) {
//   
//       
	LCD.RW=1; LCD.A0=0;	//  
	Delay(>40ns);		//    (tAS)
	LCD.E=1; Delay(>230ns);	//     E=1 (       ,     120)
	while(LCD.D.7==1);	//   
	LCD.E=0; Delay(>270ns);	//     E=1
//       
	LCD.RW=0; LCD.A0=cd; LCD.D=b;
	Delay(>40ns);		//    (tAS)
	LCD.E=1; Delay(>230ns);	//     (tDSW)
	LCD.E=0; Delay(>270ns);	//     E=1
}
